#define PM_MEMORY_CORE 0
#define PM_MEMORY_DATA 1
#define PM_MEMORY_ALL  2

#define PMI_TimeOut  30 // in minutes


typedef struct PoolsManagerItem_struc
{
struct PoolsManagerItem_struc *next; /* next item */
struct PoolsManagerItem_struc *last; /* last item */
struct PoolsManagerItem_struc *child; /* first child item */
pool p; // master pool
pool pl; // pool in list
pool parent; // pool parent in list
int index;
int tmp;
time_t tstamp;
void *data;
} *PMI_struc,_PMI_struc;

typedef void (*pm_lost_cb)(void *arg1);


void PM_Reg(int liGroup,pool parent,pool p,int liTmp,void *data);
PMI_struc PM_GetGroup(int liGroup);
PMI_struc PM_Find(PMI_struc root,pool parent,pool pl,PMI_struc *loRoot,PMI_struc *loPrev);
PMI_struc PM_FindItem(PMI_struc root,pool pl,PMI_struc *loPrev);

int PM_GetMem(int liGroup,pool liPL,int liType);
void PM_InitDaemon();
PMI_struc PM_InitRoot();
