#define SMTP_RC_DEFAULT_LANG  "en"
#define SMTP_RC_UNKNOWN       "Unknown string"
#define SMTP_RC_GATEWAY_DESCR  0
#define SMTP_RC_GATEWAY_PROMPT 1
#define SMTP_RC_REGISTER_MAIN_I 2
#define SMTP_RC_REGISTER_DATA_I  3
#define SMTP_RC_REGISTER_TITLE  4 




#define SMTP_RC_REGISTER_USEGLOBALSETTINGS_LBL  5
#define SMTP_RC_REGISTER_USEGLOBALSETTINGS_DSC  6 
#define SMTP_RC_REGISTER_ATTACHMENTS_LBL  7
#define SMTP_RC_REGISTER_ATTACHMENTS_DSC  8
#define SMTP_RC_REGISTER_ATTACHMENTS_VAL0_LBL  9
#define SMTP_RC_REGISTER_ATTACHMENTS_VAL1_LBL  10
#define SMTP_RC_REGISTER_ATTACHMENTS_VAL2_LBL  11
#define SMTP_RC_REGISTER_PGPJABBERTOMIME_LBL  12
#define SMTP_RC_REGISTER_PGPJABBERTOMIME_DSC  13
#define SMTP_RC_REGISTER_PGPTOJABBERNONMIMETOX_LBL  14
#define SMTP_RC_REGISTER_PGPTOJABBERNONMIMETOX_DSC  15


#define SMTP_RC_REGISTER_SR_MODE_LBL        16
#define SMTP_RC_REGISTER_SR_MODE_VAL0_LBL   17
#define SMTP_RC_REGISTER_SR_MODE_VAL1_LBL   18
#define SMTP_RC_REGISTER_SR_MODE_VAL2_LBL   19
#define SMTP_RC_REGISTER_SR_MODE_VAL3_LBL   20

#define SMTP_RC_REGISTER_SR_SEPARATOR_LBL   26
#define SMTP_RC_REGISTER_SR_TEXT_LBL   27

#define SMTP_RC_REGISTER_SR_HEAD            22

#define SMTP_RC_REGISTER_SR_DSC             21
#define SMTP_RC_REGISTER_SR_SEP_DSC         32
#define SMTP_RC_REGISTER_SR_TXT_DSC         33


#define SMTP_RC_REGISTER_J2SHEAD        24
#define SMTP_RC_REGISTER_S2JHEAD        25

#define SMTP_RC_REGISTER_PAID_LBL  28
#define SMTP_RC_REGISTER_ALLMESSAGESARESPAM_LBL      29
#define SMTP_RC_REGISTER_ALLMESSAGESARESPAM_DSC      30
#define SMTP_RC_REGISTER_ALLMESSAGESARESPAM_VAL0_LBL 34
#define SMTP_RC_REGISTER_ALLMESSAGESARESPAM_VAL1_LBL 35
#define SMTP_RC_REGISTER_ALLMESSAGESARESPAM_VAL2_LBL 36


#define SMTP_RC_REGISTER_USEACCOUNTSETTINGS_LBL  40
#define SMTP_RC_REGISTER_USEACCOUNTSETTINGS_DSC  41

#define SMTP_RC_GLOBAL_TITLE  50
#define SMTP_RC_GLOBAL_DATA   51
#define SMTP_RC_J2S_TITLE     52
#define SMTP_RC_J2S_DATA      53
#define SMTP_RC_S2J_TITLE     54
#define SMTP_RC_S2J_DATA      55
#define SMTP_RC_SL_TITLE      56
#define SMTP_RC_SL_DATA       57
#define SMTP_RC_WL_TITLE      58
#define SMTP_RC_WL_DATA       59

#define SMTP_RC_VCARD_HISTORY        100
#define SMTP_RC_VCARD_TITLE          101
#define SMTP_RC_VCARD_ROLE           102
#define SMTP_RC_VCARD_BDAY           103


#define SMTP_RC_REGISTER_BL_LBL      120
#define SMTP_RC_REGISTER_BL_DSC      121

#define SMTP_RC_REGISTER_AS_LBL      122
#define SMTP_RC_REGISTER_AS_DSC      123

#define SMTP_RC_REGISTER_WL_LBL      124
#define SMTP_RC_REGISTER_WL_DSC      125


#define SMTP_RC_REGISTER_RT_MODE_LBL        150
#define SMTP_RC_REGISTER_RT_MODE_VAL0_LBL   151
#define SMTP_RC_REGISTER_RT_MODE_VAL1_LBL   152
#define SMTP_RC_REGISTER_RT_NAME_LBL        153
#define SMTP_RC_REGISTER_RT_ADDR_LBL        154
#define SMTP_RC_REGISTER_RT_DSC             158
#define SMTP_RC_REGISTER_RT_MODE_DSC        155
#define SMTP_RC_REGISTER_RT_NAME_DSC        156
#define SMTP_RC_REGISTER_RT_ADDR_DSC        157

#define SMTP_RC_REGISTER_FR_MODE_LBL        160
#define SMTP_RC_REGISTER_FR_MODE_VAL0_LBL   161
#define SMTP_RC_REGISTER_FR_MODE_VAL1_LBL   162
#define SMTP_RC_REGISTER_FR_NAME_LBL        163
#define SMTP_RC_REGISTER_FR_ADDR_LBL        164
#define SMTP_RC_REGISTER_FR_DSC             168
#define SMTP_RC_REGISTER_FR_MODE_DSC        165
#define SMTP_RC_REGISTER_FR_NAME_DSC        166
#define SMTP_RC_REGISTER_FR_ADDR_DSC        167


#define SMTP_XXX_RCPT_NOTFOUND        200
#define SMTP_XXX_MUST_REGISTER        201
#define SMTP_XXX_MESSAGE_SENT         202
#define SMTP_XXX_TIMEOUT_1            203
#define SMTP_XXX_TIMEOUT_0            204
#define SMTP_XXX_JABBER_SUSPEND       208
#define SMTP_XXX_SMTP_SUSPEND         209

#define SMTP_XXX_SMTP_UNKNOWN_1       205
#define SMTP_XXX_SMTP_UNKNOWN_0       206
#define SMTP_XXX_NOSUBJECT            207
#define SMTP_CB_MESSAGE_HEADER        250



#define SMTP_RC_ID_1000 1000 // Commands
#define SMTP_RC_ID_1010 1010 // Settings
#define SMTP_RC_ID_1020 1020 // Reports
#define SMTP_RC_ID_1030 1030 // Admin's reports
#define SMTP_RC_ID_1040 1040 // Admin's settings

#define SMTP_RC_ID_1050 1050 // General
#define SMTP_RC_ID_1060 1060 // XMPP to SMTP
#define SMTP_RC_ID_1070 1070 // SMTP to XMPP
#define SMTP_RC_ID_1080 1080 // Black list
#define SMTP_RC_ID_1090 1090 // White list
#define SMTP_RC_ID_1100 1100 // Contacts list

#define SMTP_RC_ID_1110 1110 // Memory status...
#define SMTP_RC_ID_1120 1120 // Accounts memory status
#define SMTP_RC_ID_1130 1130 // Contacts memory status
#define SMTP_RC_ID_1140 1140 // SMTP memory status
#define SMTP_RC_ID_1150 1150 // Jabber memory status
#define SMTP_RC_ID_1160 1160 // Resources
#define SMTP_RC_ID_1170 1170 // Config Runtime

#define SMTP_RC_ID_1180 1180 // Accounts core memory status
#define SMTP_RC_ID_1190 1190 // Accounts data memory status 
     
#define SMTP_RC_ID_1200 1200 // Contacts core memory status
#define SMTP_RC_ID_1210 1210 // Contacts data memory status
   
#define SMTP_RC_ID_1220 1220 // Jabber messages memory status
#define SMTP_RC_ID_1230 1230 // Jabber commands memory status
   
#define SMTP_RC_ID_1240 1240 // Send message...
#define SMTP_RC_ID_1250 1250 // Folders
#define SMTP_RC_ID_1260 1260 // SMTP
#define SMTP_RC_ID_1270 1270 // Jabber
   
#define SMTP_RC_ID_1280 1280 // Status
#define SMTP_RC_ID_1290 1290 // Send offline messages
#define SMTP_RC_ID_1300 1300 // Receiving...
   
#define SMTP_RC_ID_1310 1310 // Host: 
#define SMTP_RC_ID_1320 1320 // From: 
#define SMTP_RC_ID_1330 1330 // Size: 
#define SMTP_RC_ID_1340 1340 // Status: 
   
#define SMTP_RC_ID_1350 1350 // Recipients: 

#define SMTP_RC_ID_1360 1360 // Recipients failed: 
#define SMTP_RC_ID_1370 1370 // Sending...
#define SMTP_RC_ID_1380 1380 // Jabber Backup
#define SMTP_RC_ID_1390 1390 // Jabber Backup Old
#define SMTP_RC_ID_1400 1400 // Jabber Offline
#define SMTP_RC_ID_1410 1410 // SMTP Backup
#define SMTP_RC_ID_1420 1420 // SMTP Backup Old
#define SMTP_RC_ID_1430 1430 // SMTP Offline
#define SMTP_RC_ID_1440 1440 // Temp
   
#define SMTP_RC_ID_1450 1450 // List...
#define SMTP_RC_ID_1460 1460 // Move all...
#define SMTP_RC_ID_1470 1470 // Move file...
#define SMTP_RC_ID_1480 1480 // Remove all...
#define SMTP_RC_ID_1490 1490 // Remove file...
#define SMTP_RC_ID_1500 1500 // Change file...
#define SMTP_RC_ID_1510 1510 // New file...

#define SMTP_RC_ID_1520 1520 // Send message to any recipient as gateway.
#define SMTP_RC_ID_1530 1530 // Recipient:
#define SMTP_RC_ID_1540 1540 // Message recipient.
#define SMTP_RC_ID_1550 1550 // Message Text:
#define SMTP_RC_ID_1560 1560 // Message text...

#define SMTP_RC_ID_1570 1570 // Select how many files you want get.
#define SMTP_RC_ID_1580 1580 // Files...:
#define SMTP_RC_ID_1590 1590 // Count:
#define SMTP_RC_ID_1600 1600 // All
#define SMTP_RC_ID_1610 1610 // First

#define SMTP_RC_ID_1620 1620 // Move all files to folder
#define SMTP_RC_ID_1630 1630 // Select destination folder and count of file for moving.
#define SMTP_RC_ID_1640 1640 // Destination folder:

#define SMTP_RC_ID_1650 1650 // Move one or more files to folder
#define SMTP_RC_ID_1660 1660 // Select destination folder and one or more files for moving.
#define SMTP_RC_ID_1670 1670 // Remove all files from folder

#define SMTP_RC_ID_1680 1680 // Remove one or more files from folder
#define SMTP_RC_ID_1690 1690 // Select one or more files for removing from folder.

#define SMTP_RC_ID_1700 1700 // Change one file from folder
#define SMTP_RC_ID_1710 1710 // The "Finish" button complete this command.
#define SMTP_RC_ID_1720 1720 // Cannot read file\n
#define SMTP_RC_ID_1730 1730 // Select file...
#define SMTP_RC_ID_1740 1740 // Create new file in folder

#define SMTP_RC_ID_1750 1750 // State of SMTP
#define SMTP_RC_ID_1760 1760 // Set state of SMTP.
#define SMTP_RC_ID_1770 1770 // Pause
#define SMTP_RC_ID_1780 1780 // Running
#define SMTP_RC_ID_1790 1790 // Status:

#define SMTP_RC_ID_1800 1800 // State of Jabber
#define SMTP_RC_ID_1810 1810 // Set state of Jabber
#define SMTP_RC_ID_1820 1820 // Command completed.

#define SMTP_RC_ID_1830 1830 // General settings has been configured.
#define SMTP_RC_ID_1840 1840 // XMPP to SMTP settings has been configured.
#define SMTP_RC_ID_1850 1850 // SMTP to XMPP settings has been configured.
#define SMTP_RC_ID_1860 1860 // Black list has been configured.
#define SMTP_RC_ID_1870 1870 // Message sent.
#define SMTP_RC_ID_1890 1890 // White list has been configured.

#define SMTP_RC_ID_1900 1900 // Command canceled.
#define SMTP_RC_ID_1910 1910 // Action canceled
#define SMTP_RC_ID_1920 1920 // Action canceled...

#define SMTP_RC_ID_1930 1930 // Contact %s settings%c
#define SMTP_RC_ID_1940 1940 // Account %s data memory status%c
#define SMTP_RC_ID_1950 1950 // Contact %s data memory status%c
#define SMTP_RC_ID_1960 1960 // Jabber command %s memory status%c
#define SMTP_RC_ID_1970 1970 // Jabber message %i memory status%c
#define SMTP_RC_ID_1980 1980 // SMTP message %i memory status%c
#define SMTP_RC_ID_1990 1990 // Memory status... (%i)%c
#define SMTP_RC_ID_2000 2000 // Accounts memory status... (%i)%c
#define SMTP_RC_ID_2010 2010 // Accounts core memory status... (%i)%c
#define SMTP_RC_ID_2020 2020 // Accounts data memory status... (%i)%c
#define SMTP_RC_ID_2030 2030 // Account %s data memory status... (%i)%c
#define SMTP_RC_ID_2040 2040 // Contacts memory status... (%i)%c
#define SMTP_RC_ID_2050 2050 // Contacts core memory status... (%i)%c
#define SMTP_RC_ID_2060 2060 // Contacts data memory status... (%i")%c
#define SMTP_RC_ID_2070 2070 // Account %s data memory status... (%i")%c
#define SMTP_RC_ID_2080 2080 // SMTP memory status... (%i)%c
#define SMTP_RC_ID_2090 2090 // SMTP message %s memory status... (%i")%c
#define SMTP_RC_ID_2100 2100 // Jabber memory status... (%i)%c
#define SMTP_RC_ID_2110 2110 // Jabber messages memory status... (%i)%c
#define SMTP_RC_ID_2120 2120 // Jabber message %s memory status... (%i)%c
#define SMTP_RC_ID_2130 2130 // Jabber commands memory status... (%i)%c
#define SMTP_RC_ID_2140 2140 // Jabber command %s memory status... (%i)%c
#define SMTP_RC_ID_2150 2150 // Resources memory status... (%i)%c
#define SMTP_RC_ID_2160 2160 // Config Runtime memory status... (%i)%c


#define SMTP_RC_ID_2170 2170 // Language
#define SMTP_RC_ID_2180 2180 // Urceni jazyka pro komunikaci

#define SMTP_RC_ID_2190 2190 // Send system message
#define SMTP_RC_ID_2200 2200 // Mode for sending system message from transport.
#define SMTP_RC_ID_2210 2210 // None
#define SMTP_RC_ID_2220 2220 // Message
#define SMTP_RC_ID_2230 2230 // Chat
#define SMTP_RC_ID_2240 2240 // Presence



#define SMTP_RC_ID_2250 2250 // E-mail data is overflow, limit - %i size -  %i from: %s
#define SMTP_RC_ID_2260 2260 // The sender (%s) is spammer.

#define SMTP_RC_ID_2270 2270 // You got e-mail from %s, but you are not register.%c
#define SMTP_RC_ID_2280 2280 // You got e-mail from %s, but your seting are "All is spam" or Sender isn't in roster.%c
#define SMTP_RC_ID_2290 2290 // You got e-mail from %s with empty body.%c
#define SMTP_RC_ID_2300 2300 // This mail from %s is probably spam and has not been accepted.%c

#define SMTP_RC_ID_2310 2310 // Automatically
#define SMTP_RC_ID_2320 2320 // Message
#define SMTP_RC_ID_2330 2330 // Chat

#define SMTP_RC_ID_2340 2340 // Send e-mail as:
#define SMTP_RC_ID_2350 2350 // Mode for sending e-mail to jabber.
